<!DOCTYPE html>
<html>

<head>
  <meta charset="utf-8" name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css"
    integrity="sha512-iecdLmaskl7CVkqkXNQ/ZH/XLlvWZOJyj7Yy7tcenmpD1ypASozpmT/E0iPtmFIB46ZmdtAc9eNBvH0H/ZpiBw=="
    crossorigin="anonymous" referrerpolicy="no-referrer" />
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <!-- Import DataTable Library -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.25/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.25/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.25/js/dataTables.bootstrap4.min.js"></script>
</head>
<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  /* Mảng userObjects là mảng chứa dữ liệu user. Từng phần tử là object
  */
  var gStudents = [
    {
      id: 2, // tự tăng
      studentCode: "1356783",
      firstname: "Ngo Van",
      lastname: "Quan",
      age: 18,
      email: "quan@gmail.com",
      studyYear: 2015
    },
    {
      id: 3, // tự tăng
      studentCode: "5676783",
      firstname: "Quang",
      lastname: "Tấn",
      age: 18,
      email: "tannnn@gmail.com",
      studyYear: 2017
    },
    {
      id: 4, // tự tăng
      studentCode: "8906783",
      firstname: "Ngọc",
      lastname: "Hà",
      age: 18,
      email: "havuccn@gmail.com",
      studyYear: 2019
    },
    {
      id: 5, // tự tăng
      studentCode: "1356783",
      firstname: "Dung",
      lastname: "Tran",
      age: 18,
      email: "dungtan@gmail.com",
      studyYear: 2019
    },
    {
      id: 6, // tự tăng
      studentCode: "1356783",
      firstname: "Tinh",
      lastname: "Huu",
      age: 18,
      email: "huyunns@gmail.com",
      studyYear: 2014
    },

  ];

  var gSubjects = [
    {
      id: 5, // tự tăng
      subjectCode: "MATH101",
      subjectName: "Toán cao cấp 1"
    },
    { id: 6, subjectCode: "MATH101", subjectName: "Toán cao cấp 2" },
    { id: 7, subjectCode: "VAN104", subjectName: "Văn cao cấp 1" },
    { id: 8, subjectCode: "ENG101", subjectName: "Tiếng Anh 2" },
    { id: 9, subjectCode: "MATH101", subjectName: "Tiếng Anh 1" },
    // điền thêm 04 môn học nữa
  ];

  var gGrades = [
    {
      id: 2, // tự tăng
      studentId: 2,
      subjectId: 5,
      grade: 8,
      examDate: "13/04/2021"
    },
    { id: 3, studentId: 2, subjectId: 5, grade: 8, examDate: "13/04/2021" },
    { id: 4, studentId: 4, subjectId: 7, grade: 10, examDate: "13/05/2021" },
    { id: 5, studentId: 5, subjectId: 6, grade: 10, examDate: "13/7/2021" },
    { id: 6, studentId: 6, subjectId: 5, grade: 7, examDate: "13/04/2011" },
    { id: 7, studentId: 3, subjectId: 6, grade: 7, examDate: "20/04/2021" },
    { id: 8, studentId: 6, subjectId: 9, grade: 5, examDate: "30/6/2021" },
    { id: 9, studentId: 3, subjectId: 8, grade: 5, examDate: "1/8/2021" },
    { id: 10, studentId: 2, subjectId: 8, grade: 2, examDate: "7/9/2021" },
    { id: 11, studentId: 4, subjectId: 5, grade: 2, examDate: "13/`0/2021" },
    // điền thêm 9 kết quả thi nữa
  ];

  var gSTT = 1
  var gNameCol = ["id", "studentId", "subjectId", "grade", "examDate",];
  const gSTT_COL = 0;
  const gSTUDENT_COL = 1;
  const gSUBJECTS_COL = 2;
  const gGRADE_COL = 3;
  const gDATE_COL = 4;
  // hàm ô students
  function mappingStudent(paramStudent) {
    var vStudent = ""
    for (var bI = 0; bI < gStudents.length; bI++) {
      if (paramStudent == gStudents[bI].id) {
        vStudent = (gStudents[bI].firstname + " " + gStudents[bI].lastname)
      }
    }
    return vStudent
  }
  // hàm ô subject
  function mappingSubject(paramStudent) {
    var vSubject = ""
    for (var bI = 0; bI < gSubjects.length; bI++) {
      if (paramStudent == gSubjects[bI].id) {
        vSubject = (gSubjects[bI].subjectName)
      }
    }
    return vSubject
  }
  /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoading()
    $("#btn-filter").on("click", function () {
      onBtnFilterClick()
    })

  })

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  // hàm load trang
  function onPageLoading() {
    $("#student-table").DataTable({
      columns: [
        { data: gNameCol[gSTT_COL] },
        { data: gNameCol[gSTUDENT_COL] },
        { data: gNameCol[gSUBJECTS_COL] },
        { data: gNameCol[gGRADE_COL] },
        { data: gNameCol[gDATE_COL] },
      ],
      columnDefs: [
        {
          targets: gSTT_COL,
          class: "text-primary",
          render: function () {
            return gSTT++
          }
        },
        {
          targets: gSTUDENT_COL,
          class: "text-center",
          render: mappingStudent
        },
        {
          targets: gSUBJECTS_COL,
          class: "text-right text-success",
          render: mappingSubject
        }
      ]
    })
    loadDatatoTable(gGrades)
    loadDataToSelectStudent()
    loadDataToSelectSubject()

  }

  function onBtnFilterClick() {
    console.log("Lọc dữ liệu")
    var Ojb = {
      student: "",
      subject: ""
    }

    getDataFilter(Ojb)

    filterData(Ojb)
    

  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  // hàm load Data to select STUDENT
  function loadDataToSelectStudent() {
    var vSelectStudent = $("#select-student")

    $("<option>", {
      value: 0,
      text: "-- Hãy chọn học sinh --"
    }).appendTo(vSelectStudent)

    for (let bI = 0; bI < gStudents.length; bI++) {
      $("<option>", {
        value: gStudents[bI].id,
        text: gStudents[bI].firstname + " " + gStudents[bI].lastname
      }).appendTo(vSelectStudent)
    }
  }

  // hàm load Data to select SUBJECT
  function loadDataToSelectSubject() {
    var vSelectSubject = $("#select-subject")

    $("<option>", {
      value: 0,
      text: "-- Hãy chọn Subject --"
    }).appendTo(vSelectSubject)

    for (let bI = 0; bI < gSubjects.length; bI++) {
      $("<option>", {
        value: gSubjects[bI].id,
        text: gSubjects[bI].subjectName
      }).appendTo(vSelectSubject)
    }
  }

  // hàm thu thập dữ liệu lọc
  function getDataFilter(paramFilter) {
    paramFilter.student = $("#select-student").val();
    paramFilter.subject = $("#select-subject").val()

  }
  // hàm lọc dữ liệu
  function filterData(paramFilter) {
    var vFilterResult = []
    // trường hợp ô STUDENT HOẶC Ô SUBJETC được nhập
    if (paramFilter.student != 0 || paramFilter.subject != 0) {
      vFilterResult = gGrades.filter(function (item) {
        return (item.studentId == paramFilter.student || item.subjectId == paramFilter.subject ||
        item.studentId == paramFilter.student && item.subjectId == paramFilter.subject)
      })
  }
 // trường hợp ô STUDENT và Ô SUBJETC đều được được nhập HOẶC CẢ 2 Ô ĐỀU KHONG ĐƯỢC NHẬP
  if (paramFilter.student != 0 && paramFilter.subject != 0 || paramFilter.student == 0 && paramFilter.subject == 0) {
      vFilterResult = gGrades.filter(function (item) {
        return (item.studentId == paramFilter.student && item.subjectId == paramFilter.subject 
        || paramFilter.student == 0 && paramFilter.subject == 0)
      })
  }

    console.log(vFilterResult)
    loadDatatoTable(vFilterResult)
  }

  // hàm load bảng
  function loadDatatoTable(paramData) {
    var vTable = $("#student-table").DataTable()
    vTable.clear()
    vTable.rows.add(paramData)
    vTable.draw()
  }
</script>

<body>
  <div class="container-fluid">
    <div class="text-center mt-2 mb-2">
      <h2>F200 - Lịch sử học tập</h2>
    </div>
    <div class="jumbotron container">
      <div class="row form-group mb-0">
        <div class="col-sm-5">
          <div class="row">

            <label class="col-form-label col-sm-3">Student</label>

            <div class="col-sm-9">
              <select id="select-student" class="form-control">
              </select>
            </div>
          </div>

        </div>
        <div class="col-sm-5">
          <div class="row">

            <label class="col-form-label col-sm-3">Subject</label>

            <div class="col-sm-9">
              <select id="select-subject" class="form-control">
              </select>
            </div>
          </div>
        </div>
        <div class="col-sm-2">
          <button id="btn-filter" class="btn btn-info">Lọc dữ liệu</button>
        </div>
      </div>
    </div>

    <div class="container-fluid">
      <table class="table table-bordered table-striped table-hover" id="student-table">
        <thead class="thead-dark">
          <tr>
            <th>STT</th>
            <th>Student</th>
            <th>Môn học </th>
            <th>Điểm</th>
            <th>Ngày Thi</th>

          </tr>
        </thead>
      </table>
    </div>
</body>

</html>